<template>
    <div>
        <br>
        <div>
            <h5>Neue Gruppe hinzufügen</h5>
            <b-button id="show-btn" variant="success" @click="showModal">
                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            <b-modal ref="my-modal" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Gruppennummer eingeben"
                                        v-model.number="gruppe.nummer"></b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Raum auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="gruppe.raumId">
                                        <option v-for="raum in raeume" v-bind:key="raum.id"
                                            :value="raum.raum_id"> {{ raum.name }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <!-- <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Raum ID eingeben"
                                        v-model="gruppe.raumId"></b-form-input>
                                </b-col>
                            </b-row> -->

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppenart wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="gruppe.gruppenEnums">
                                        <option value="NT">NT</option>
                                        <option value="FIA">FIA</option>
                                        <option value="SW">SW</option>
                                    </select>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Qualifying</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="gruppe.qualifying">
                                        <option value="true">Ja</option>
                                        <option value="false">Nein</option>
                                    </select>
                                </b-col>
                            </b-row>
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postGruppe()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <div>
            <b-modal ref="my-modal1" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Gruppennummer eingeben"
                                        v-model.number="editGruppen.nummer"></b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Raum auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editGruppen.raumId">
                                        <option v-for="raum in raeume" v-bind:key="raum.id"
                                            :value="raum.raum_id"> {{ raum.name }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>                   

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppenart wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editGruppen.gruppenEnums">
                                        <option value="NT">NT</option>
                                        <option value="FIA">FIA</option>
                                        <option value="SW">SW</option>
                                    </select>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Qualifying</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editGruppen.qualifying">
                                        <option value="true">Ja</option>
                                        <option value="false">Nein</option>
                                    </select>
                                </b-col>
                            </b-row>
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="putGruppe()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <br>

        <table class="table">
            <tbody>
                <tr>                   
                    <th>Gruppenart</th>
                    <th>Nummer</th>
                    <th>Teilnehmer in der Gruppe</th>
                    <th>Qualifying</th>
                    <th>Raum</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="gruppe in gruppen" v-bind:key="gruppe.id">
                    <td>{{ gruppe.gruppenEnums }}</td>
                    <td>{{ gruppe.nummer }}</td>
                    

                    <td>

                        
                        <button type="button" class="btn btn-warning" data-toggle="collapse"
                            :data-target="'#collapse' + gruppe.gruppen_ID" aria-expanded="false"
                            :aria-controls="'collapse' + gruppe.gruppen_ID">
                            TeilnehmerInnen anzeigen
                        </button>
                        

                        <div :id="'collapse' + gruppe.gruppen_ID" class="collapse hide"
                            :aria-labelledby="'heading' + gruppe.gruppen_ID" data-parent="#accordion">
                            <ul class="list-group" v-for="teilnehmer in gruppe.teilnehmerInnenSet"
                                v-bind:key="teilnehmer.id">
                                <li class="list-group-item">Name: {{ teilnehmer.name }}, ID:{{ teilnehmer.id }}
                                </li>

                            </ul>
                        </div>

                        
                    </td>
                    <td>{{ gruppe.qualifying }}</td>
                    <td>{{ gruppe.raum.name }} {{ gruppe.raum.raum_id }}</td>
                    <td>
                        <b-button id="show-btn" @click="showModal1(gruppe.gruppen_ID), editGruppe(gruppe)"
                            variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteGruppe(gruppe.gruppen_ID)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>
        </table>

    </div>
</template>

<script>

export default {
    name: "GruppenListe",
    data() {
        return {
            modalShow: false,
            gruppe: {
                nummer: '',
                gruppenEnums: '',
                qualifying: '',
                raumId: ''
            },
            editGruppen: {
                nummer: '',
                gruppenEnums: '',
                qualifying: '',
                raumId: '',
                gruppen_ID: ''
            }
        }
    },
    computed: {
        gruppen() {
            return this.$store.state.gruppen;
        },
        raeume() {
            return this.$store.state.raeume;
        }
    },
    methods:
    {
        deleteGruppe(gruppen_ID) {
            this.$store.dispatch('deleteGruppe', gruppen_ID)
        },

        postGruppe() {
            this.$store.dispatch('postGruppe', this.gruppe)
            this.hideModal()
        },

        putGruppe() {
            this.$store.dispatch('putGruppe', this.editGruppen)
            this.hideModal1()
        },
        getGruppeById(gruppen_id) {
            this.$store.dispatch('getGruppeById', gruppen_id)
        },


        async editGruppe(gruppe) {
            this.editGruppen.nummer = gruppe.nummer;
            this.editGruppen.gruppenEnums = gruppe.gruppenEnums;
            this.editGruppen.qualifying = gruppe.qualifying;
            this.editGruppen.raumId = gruppe.raumId;
            this.editGruppen.gruppen_ID = gruppe.gruppen_ID;
        },
        resetModal() {
            this.gruppe.nummer = ''
            this.gruppe.gruppenEnums = ''
            this.gruppe.qualifying = ''
            this.gruppe.raumId = ''
        },
        showModal() {
            this.$refs['my-modal'].show()
        },
        showModal1() {
            this.$refs['my-modal1'].show()
        },
        hideModal() {
            this.$refs['my-modal'].hide()
        },
        hideModal1() {
            this.$refs['my-modal1'].hide()
        }
    },
    mounted() {
        this.$store.dispatch('getAlleGruppen');
        this.$store.dispatch('getAlleRaeume');
    }
}

</script>